//********************************************************************
//						MD  ļ Ķ
//		Powered by @J--S Studio			Johnhans		2004.2
//********************************************************************

#ifndef MD_FILE_H
#define MD_FILE_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef	MDENGINE2P_EXPORTS
#define MDENGINE_API __declspec(dllexport)
#else
#define MDENGINE_API __declspec(dllimport)
#endif

#include "..\common.h"
typedef struct JSPackFileHeader		// ļͷϢ
{
	DWORD	JSPK;		// 'J' 'S' 'P' 'K'   0x4B50534A
	BYTE	Version;	// 0x01
	BYTE	ExInfo;		// ExInfo&0x0f ⲿѹ*
						// ExInfo&0x80 ļǷ
	WORD	DirNum;		// Ŀ¼*
	DWORD	FileNum;	// ļ*
	DWORD	FOffset;	// ļϢƫƣļĩβλã*
}JSPKHeader;

typedef struct JSExtendModule		// ⲿչϢ
{
	BYTE  NameSize;		// ִС*
	char  Name[255];	// *
	BYTE  FNameSize;	// ļС*
	char  FName[255];	// ļ*
	DWORD Version;		// 汾*
}JSEXModule;

typedef struct JSDirectoryInfo		// Ŀ¼ṹϢ
{
	BYTE NameSize;	// Ŀ¼С*
	char Name[255];	// Ŀ¼*
	WORD MIN_Child;	// Ŀ¼СID*
	WORD MAX_Child; // Ŀ¼ID*
}JSDirInfo;

struct JSFileInfo		// ļṹϢ
{
	BYTE  NameSize;	// С*
	char  Name[255];// *
	DWORD Offset;	// ƫƣļʼλã*
	DWORD SizeOri;	// ѹǰݴС*
	DWORD SizeCom;	// ѹݴС*
	WORD Root;		// ϼ 0xFFFF:(κμ)*
	BYTE  Attribute;// ļ 0:ѹ 1:ⲿչѹ 2:ڲLZWѹ*
};

struct MaskCode		// 
{
	BYTE	b[8];
	WORD	w[8];
	DWORD	d[8];
	BYTE	s[16];
	BYTE	c[16];
};

typedef DWORD ( *getProviderTypeDLL)(void);
typedef bool ( *setFileHandleDLL)(HANDLE,char *,char *);
typedef DWORD ( *getFileSizeDLL)(void);
typedef bool ( *LocateFileDLL)(char *,char *);
typedef bool ( *ReadDLL)(LPVOID,DWORD len);

typedef char* ( *getProviderNameDLL)(void);
typedef DWORD ( *getProviderVersionDLL)(void);
typedef char* ( *getProviderInfoDLL)(void);
typedef DWORD ( *getMemNeededDLL)(DWORD);
typedef bool ( *EncodeDLL)(LPBYTE,DWORD,LPBYTE,DWORD&);
typedef bool ( *DecodeDLL)(LPBYTE,DWORD,LPBYTE);

class MDENGINE_API CMD_File  
{
public:
	CMD_File();
	CMD_File(char *ProviderName);
	virtual ~CMD_File();

public:
	void	EnableErrMSG(bool bshowerr);	// orֹϢ
	DWORD	GetErrCode(void);				// õ
	void	EnableExt(bool bEnable);		// orչ
	void	SetExt(char *path);				// չ·

	bool	ConnectProvider(char *ProviderName);	// ӵⲿFileProvider
	void	FreeProvider();							// ͷFileProvider

	bool	Open(char* FileName,bool bReadOnly=true,bool bPacked=false,char *password=NULL);
	void	Close();
	bool	Locate(char* PathName,char *password=NULL);	// λһļ
	DWORD	GetLength();				// ȡõǰļĴС
	bool	Read(LPBYTE *buffer=NULL,DWORD size=0);	// ȡǰļݵ滺
	bool	Write(LPCVOID buffer,DWORD size);	// д뵱ǰļ
	bool	Seek(long move, BYTE method=FILE_CURRENT);	// ƶǰļָ

	LPBYTE	GetBuffer(){ return m_lpBuffer; }	// ȡļݻ
	DWORD	GetBufferLength(){ return m_BufferLen; }
	bool	WriteBufferToFile(char *PathName);	// дļ

private:
	HANDLE	m_hFile;				// ļ
	HANDLE	m_hExtra;				// 򿪵չļ
	bool	m_bEnableExtra;			// Ƿչѯ
	char	m_ExtraPath[MAX_PATH];	// չĿ¼·
	char	m_FileName[MAX_PATH];	// ļ
	char	m_Password[MAX_PWD];	// ļ
	LPBYTE	m_lpBuffer;				// ݻ
	DWORD	m_BufferLen;			// ݻС
	bool	m_bShowErrMSG;			// Ƿʾ
	DWORD	m_ErrCode;				// ǰ
	bool	m_bPacked;				// ļΪ
	DWORD	m_LocatedFileID;		// λļID

//		JSPackFileṹ
	JSPKHeader		m_pkHeader;		// ѹļͷϢ
	JSEXModule		*m_lppkEXModule;// ⲿģϢ
	JSDirInfo		*m_lppkDirInfo;	// Ŀ¼ṹϢ
	JSFileInfo		*m_lppkFileInfo;// ļϢ

	MaskCode		m_Hash;

//		FileProvider,ָ
	HINSTANCE	m_hInstProvider;
	getProviderTypeDLL	fp_getProviderType;
	getFileSizeDLL		fp_getFileSize;
	setFileHandleDLL	fp_setFileHandle;
	LocateFileDLL		fp_LocateFile;
	ReadDLL				fp_ReadFromPacker;

private:
	// ********* ͨļĲ Gen_XXXX() ******** //
	bool	Gen_Open(char* filename, bool readonly,HANDLE *file=NULL); // ļ
	void	Gen_Close(void); // ر
	DWORD	Gen_GetFileSize(HANDLE *file=NULL); // ȡļС
	bool	Gen_Seek(long move, BYTE method); // ƶļָ
	bool	Gen_Read(LPBYTE *buffer, DWORD size,HANDLE *file=NULL); // ȡļ
	bool	Gen_Write(LPCVOID buffer, DWORD size,HANDLE *file=NULL); // дļ

	// ********* ѹļĲ Pak_XXXX() ******** //
	bool	Pak_Open(char* filename,char *password); // ļ
	void	Pak_Close(void); // رļ
	bool	Pak_LocateFile(char *pathname,char *password); // Ҷλļ
	DWORD	Pak_GetFileSize(void); // ȡõǰļС
	bool	Pak_Read(LPBYTE *buffer);


private:
	void	ShowErrMSG();	// ʾϢ

	bool	InitPackInfo();	// ʼѹĿ¼ļϢ
	bool	Decode(LPVOID in, unsigned in_len, LPVOID out,BYTE Attribute);	// 
	bool	AnalyzePath(char **start,char *res);	// ļ·
	void	SetPassword(BYTE pwd[],BYTE crc[]);		// ÷

	BYTE	Encrypt(BYTE s,BYTE bit);
	WORD	Encrypt(WORD s);
	DWORD	Encrypt(DWORD s);
	LPBYTE	GetCRCByte(bool r=false);
	void	Encrypt(char *s,BYTE len);
	void	Encrypt(BYTE *s,DWORD len);
	void	EncryptHead(JSPackFileHeader &head);
	void	EncryptReset();
};

#endif